#include "linda.h" 
 
#define MAXVAL 200

void primes(void *);

void
threadmain(int argc, char *argv[]) 
{ 
    int last, i, ok;
 
	USED(argc);
	USED(argv);

	last = 0;

    lindainit();
 
    for (i = 2; i < MAXVAL; i++) { 
       out("%s%d","primeargs",i); 
       spawn(primes);
    } 
 
    for (i = 2; i < MAXVAL; i++) { 
        rd("%s%d?d","primes",i,&ok); 
        if (ok == 1)  
            last = i; 
    } 

    print("greatest prime is %d\n",last); 

	threadexits(0);
} 


void
primes(void *) 
{ 
    int me, i, limit, ok;  
   
    in("%s?d", "primeargs", &me); 
    limit = sqrt((double)me) + 1; 
    for(i = 2; i < limit; i++) { 
        rd("%s%d?d","primes",i,&ok); 
        if(ok && (me%i == 0)) { 
           out("%s%d%d", "primes", me, 0); 
           return;
        } 
     } 
   
     out("%s%d%d", "primes", me, 1); 
} 
